package tk.antoine.roux.springcloudconfig.configurations;

import org.springframework.cloud.bootstrap.encrypt.KeyProperties;
import org.springframework.cloud.config.server.config.DefaultTextEncryptionAutoConfiguration;
import org.springframework.cloud.config.server.encryption.TextEncryptorLocator;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration(proxyBeanMethods = false)
public class Encryption {

    private final DefaultTextEncryptionAutoConfiguration defaultTextEncryptionAutoConfiguration;

    public Encryption() {
        defaultTextEncryptionAutoConfiguration = new DefaultTextEncryptionAutoConfiguration();
    }

    @Bean
    public TextEncryptorLocator textEncryptorLocator(MultiKeyProperties multiKeyProperties) {
        return keys -> {
            KeyProperties keyPropertiesForClient = multiKeyProperties.encrypt().get(keys.get("application"));
            return defaultTextEncryptionAutoConfiguration.defaultTextEncryptor(keyPropertiesForClient);
        };
    }

}
